/***************************************************************************
driver.h  -  description
-------------------
begin                : Thu Apr 27 2000
copyright            : (C) 2000 by Martin Erdtmann
email                : martin.erdtmann@gmx.de
***************************************************************************/

/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/

#ifndef TREIBER_H
#define TREIBER_H


/**
*the base class which provides mathematical routines for the KFilter App.
*@author Martin Erdtmann
*/
#include <qstring.h>

class driver {
public:
	driver();
	~driver();
	
	double Rdc,Lsp,F0,Qtc,Qms,Qe,Dm,Vas,Vb,Fb,F3,Ql,Fs,V2,gain;
	
	double	ResultSchall[300],ResultImpedanz[300],Bauteil[49];
	int		GTyp,GTypProposal,Phase_flag,Parameter_flag,Tiefpass_flag,AkustikESB_flag,Realschall_flag,	
		Anzahl,i;
	bool 	PressureisActive,ImpedanzisActive,SummaryisActive,ScalarSummaryisActive,
		ImpedanzSummaryisActive,InvertPhase;
	
	void setmodified(void);
	void initContents(void);
	
	void Schall(void);
	void Impedanz (void);
	void Berechneparameter(void);
	void invertImpedanz(void);
	
	QString	GetTitle();
	void	SetTitle( const QString& a_qstringTitle );
private:
	
	void ESBberechnen(void);
	void Akustik(void);
	void Quotient(void);
	void inverse(double *a,double *b);
	int  Anzahlcheck(void);
	void Parallelberechnung(void);
	void Reihenberechnung(void);
	
	bool dirty_schall,dirty_impedanz,show_reflex_only;
	
	double
		//    Anpassung,Ausgleichsfaktor,Versatz,
		Consta,Constb,Constc,Constd,AktivC1,
		AktivC2,AktivL1,AktivL2,AktivF,TiefpassL,TiefpassC,TiefpassQ,Tiefpassfc,
		AktivQ,MembranDm,StrahlC,Norm,calibrate,Faktor,
		f,qx,qy,x,y,xa,ya, //Real und Im-Teile zur Laufzeit
		SystemQ,C2,L2,R2,C,L,R,Cakustik,Lakustik;
		
	QString	m_qstringTitle;
};

#endif
